; IMPORTANT
; To run these tests;
;1. Make the included keyboard macro the first item on the macro menu.
;   (The macro will cut 100 lines from the top and then paste them at the end)
;2. Use Options / Make Manu and count the number of entries excluding separators.
;3. Use Options / Tools Manu and count the number of entries excluding separators.
;4. Adjust the timers and command id's and rebuild the project.
;5. Make shure there are 4 projects on the mru list and that each of the projects
;   has at least one auto load file.

.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include RadASM_Tester.inc

.code

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################

Debug proc
    LOCAL	hwnd:dword

	.if !fPause
	    invoke FindWindow,addr szWinClass,NULL
	    .if !eax
	        invoke WinExec,addr szCommandLine,SW_SHOWNORMAL
	        invoke FindWindow,addr szWinClass,NULL
	    .endif
	    .if eax
;        	invoke PostMessage,eax,WM_COMMAND,nCmnd,0
	        invoke SendMessage,eax,WM_COMMAND,nCmnd,0
	    .endif
	.endif
    ret

Debug endp

TimerProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	
	.if nCount
		invoke Debug
		dec		nCount
	.endif
	ret

TimerProc endp

DlgProc	proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if	eax==WM_INITDIALOG
		invoke SetTimer,hWin,100,150,addr TimerProc
	.elseif	eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDOK
				invoke KillTimer,hWin,100
; IMPORTANT
; Adjust interval to better match the speed of your computer
; The selected interval is for an Intel 3.2 GHz PIV
				invoke SetTimer,hWin,100,100,addr TimerProc
				; Open 4'th entry on mru project list
; IMPORTANT
; To get this number count the numer of items on the Make menu, excluding separators. Then add 20004.
				mov		nCmnd,20013
				; Repeat a 1000 times
				mov		nCount,1000
			.elseif eax==1001
				invoke KillTimer,hWin,100
; IMPORTANT
; Adjust interval to better match the speed of your computer
; The selected interval is for an Intel 3.2 GHz PIV
				invoke SetTimer,hWin,100,150,addr TimerProc
				; Run first keyboard macro
; IMPORTANT
; To get this number count the numer of items on the Make menu and the Tools menu. Then add 20005.
				mov		nCmnd,20023
				; Repeat a 1000 times
				mov		nCount,1000
			.elseif eax==IDCANCEL
				mov		nCount,0
			.elseif eax==1002
				xor		fPause,TRUE
				.if ZERO?
					invoke SetDlgItemText,hWin,1002,addr szPause
				.else
					invoke SetDlgItemText,hWin,1002,addr szContinue
				.endif
			.endif
		.endif
	.elseif	eax==WM_CLOSE
		invoke KillTimer,hWin,100
		invoke EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

end start
